#!/mnt/usb/Resources/usr/bin/python2.6
# THAT LINE ABOVE NEEDS TO BE CHANGED WHEN RUNNING ON THE ROUTER!!!!
# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# Old: !/usr/bin/python2.6

# V1
# Send data to a URL
# Receive data from a dynamic URL

DEBUGMODE = False
# REMEMBER TO CHANGE THIS FOR EACH NEW VERSION
DEBUGURL = 'http://localhost/testing/tweetsign/_future/v4/online/output.php'


# =================================
#            IMPORTS
# =================================

'''
import tweepy
import base64
import sys
import traceback
from random import choice
import urllib

import time
import ConfigParser
if(not DEBUGMODE):
  import ledSignDriver
'''

# New version imports
import sys
import traceback
import time
import ConfigParser
import urllib
if(not DEBUGMODE):
  import ledSignDriver

def normalize(string_with_double_quotes):
  if(not string_with_double_quotes.isdigit()):
    newString = string_with_double_quotes.replace('"','')
    #print newString
    if(newString.isdigit()):
      #print "It's a digit!"
      return int(newString)
    else:
      return newString
  else:
    try:
      return int(string_with_double_quotes)
    except:
      return string_with_double_quotes

def main(argv):

  # WE PROBS DON'T NEED THIS ANY MORE - BUT CMD LINE MIGHT BE USEFUL
  # Set defaults
  user = 'jack' # Jack Dorsey, Twitter Founder
  tweetToDisplay = 1 # Display latest tweet by default
  
  # Handle command-line arguments
  confirmationList = ['true', 'y', 'yes']
  for arg in argv:
    # Specify user
    if '-u=' in arg.lower():
      arg = arg.lower().replace('-u=','')
      user = arg
    # Specify which tweet to display (0 for latest, 18 for oldest available)
    if '-tweet=' in arg.lower():
      arg = arg.lower().replace('-tweet=','')
      # TODO: Handle this better
      try:
        tweetToDisplay = int(arg)
      except:
        pass



  lastTweet = ''
  
  # Create an instance of the sign driver
  if(not DEBUGMODE):
    sign = ledSignDriver.ledSign('/dev/usb/tts/0')

  # Use the configuration parser to read the user settings
  config = ConfigParser.ConfigParser()

  # Continuously check the user settings and make any necessary updates
  # All the sleeping is handled within the individual operating mode branches
  while(1):
    config_filesrc = 'config/user_settings.ini'
    config.read(config_filesrc)

    '''
    operating_mode = normalize(config.get('general','operating_mode'))    
    scrolling_mode = normalize((config.get('general','scrolling_mode')))
    scrolling_speed = normalize((config.get('general','scrolling_speed')))
    shared_polling_interval = normalize((config.get('general','shared_polling_interval')))
    '''

    scrolling_mode = normalize((config.get('general','scrolling_mode')))
    scrolling_speed = normalize((config.get('general','scrolling_speed')))
    id = normalize(config.get('general','id'))
    keycode = normalize(config.get('general','keycode'))
    shared_polling_interval = normalize((config.get('general','shared_polling_interval')))

    server_url = normalize(config.get('general','server_url'))

    # OLD: 'http://delveintothis.com/mqp/final/final/output.php'
    PRODUCTIONURL = server_url
    if(DEBUGMODE):
      GETURL = DEBUGURL
    else:
      GETURL = PRODUCTIONURL
    
    #print operating_mode, user, scrolling_speed

    print "ID: " + str(id)
    print "Keycode: " + str(keycode)
    print "Polling interval (seconds): " + str(shared_polling_interval)

    # Encode the data to send as a GET request
    data = urllib.urlencode({"id" : id, "keycode" : keycode})

    f = urllib.urlopen(GETURL + '?' + data)
    
    status = f.read()
    f.close()

    # Only go through this iteration if we find some data from the server
    if(status):
      if(lastTweet != status):
        try:
          print status + ''
          lastTweet = status
          # Also put it up on the sign
          if(not DEBUGMODE):
            sign.writeText(status, scrolling_mode, "center", scrolling_speed)                      
        except:
          message = "Tweet contained non-supported characters and will not be displayed.  Trying next tweet in a bit."
          print message
          # Also put it up on the sign
          if(not DEBUGMODE):
            sign.writeText(message, scrolling_mode, "center", scrolling_speed)
      else:
        # Don't do anything
        print 'Tweet is still the same: ' + lastTweet
        
      print 'Sleeping for ' + str(shared_polling_interval) + ' seconds'
      time.sleep(shared_polling_interval)


# ########################################################
# # THESE MAY NO LONGER BE NEEDED

# THESE ARE ALL HELPER FUNCTIONS USED - CREATED BY AJAY
def getAllDataFromFile(filepath):
    openFile = open(filepath, 'r')
    lines = ''.join(openFile.readlines()).strip()
    return lines


if __name__ == "__main__":
  # Time in seconds
  time_before_trying_again = 60
  # Run the primary script with the system arguments if any
  # If an error occurs, wait X seconds and try again
  while(1):
    try:
      main(sys.argv)
    except Exception as e:
      print "ERROR OCCURED IN MAIN SCRIPT: \n"
      print e
      print "Traceback"
      print '='*50
      print traceback.print_exc(file=sys.stdout)
      print '='*50
      print "We're going to try again in " + str(time_before_trying_again) + " seconds."
      time.sleep(time_before_trying_again)        
